<?php
/**
* Plugin Media Page Enhancement
*
* @package	PLX
* @version	1.0
* @date	01/10/16
* @author Bronco
**/
class Media_Page_Enhancement extends plxPlugin {
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		
		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('AdminMediasFoot','AdminMediasFoot');
		$this->addHook('AdminMediasPrepend','AdminMediasPrepend');
		$this->addHook('AdminMediasTop','AdminMediasTop');
		$this->addHook('AdminMediasUpload','AdminMediasUpload');
		$this->addHook('AdminPrepend','AdminPrepend');
		$this->addHook('showDropZone','showDropZone');
	
	}

	# Activation / desactivation
	public function OnActivate() {
		# code à executer à l’activation du plugin
	}
	public function OnDeactivate() {
		# code à executer à la désactivation du plugin
	}
	

	########################################
	# HOOKS
	########################################


	########################################
	# AdminMediasUpload
	########################################
	# Description:
	public function AdminMediasUpload(){
		echo '<hr/>
		<fieldset class="col sml-12 lrg-6">
		<label>⬇ Télécharger via l\'URL d\'un fichier</label>
		<input type="url" name="get_from_url" class="full-width"/>
		</fieldset>
		';
	}


	########################################
	# AdminMediasFoot
	########################################
	# Description:
	public function AdminMediasFoot(){
		echo '<div id="dropzone">⇯</div>
		<link rel="stylesheet" href="'.PLX_PLUGINS.'Media_Page_Enhancement/style.css"/>
		<script src="'.PLX_PLUGINS.'Media_Page_Enhancement/dragdrop.js"></script>
		<script>
			// cosmetic changes (impossible with hooks: js dom node moving is dirty, I know... (╯°□°）╯︵ ┻━┻ )
			link=document.querySelector("a.back")
			
			if (link){document.querySelector("#form_uploader .action-bar").innerHTML+=link.outerHTML}

		</script>';

	}

	########################################
	# AdminMediasPrepend
	########################################
	# Description:
	public function AdminMediasPrepend(){
		global $plxAdmin;
		echo '<?php $_SESSION["sort_medias"]=$sort="date_asc";?>';
		if (!empty($_POST['get_from_url'])){
			$folder=trim($plxAdmin->aConf['medias']).trim($_SESSION['folder']);
			$this->curlTo(strip_tags($_POST['get_from_url']),$folder);
		}
	}

	########################################
	# AdminMediasTop
	########################################
	# Description:
	public function AdminMediasTop(){

	}

	########################################
	# AdminPrepend
	########################################
	# Description:
	public function AdminPrepend(){

	}

	########################################
	# showDropZone($target_folder)
	########################################
	# Description:
	public function showDropZone($target_folder){

	}

	
	########################################
	# curlTo($target_folder)
	########################################
	# Description:
	public function curlTo($url,$target_folder,$pretend=true){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept-Charset: UTF-8'));
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,  FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        if (!ini_get("safe_mode") && !ini_get('open_basedir') ) {curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);}
        curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
        if ($pretend){curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:19.0) Gecko/20100101 Firefox/19.0');}

        $data = curl_exec($ch);
        $response_headers = curl_getinfo($ch);

        // Google seems to be sending ISO encoded page + htmlentities, why??
        if($response_headers['content_type'] == 'text/html; charset=ISO-8859-1') $data = html_entity_decode(iconv('ISO-8859-1', 'UTF-8//TRANSLIT', $data)); 
        

        curl_close($ch);

       	if (!empty($data)){
			$fil=explode('?',basename($url));
			$fil=$fil[0];
			$fil=plxUtils::title2url(dirname(strip_tags($url))).$fil;			
			file_put_contents(PLX_ROOT.$target_folder.$fil, $data);
		}
	}

	

}





/* Pense-bete:
 * Récuperer des etres du fichier eters.xml
 *	$this->getParam("<nom du etre>")
 *	$this-> setParam ("1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_PLUGINS
 * PLX_CONFIG_PATH
 * PLX_ADMIN (true si on est dans admin)
 * PLX_CHARSET
 * PLX_VERSION
 * PLX_FEED
 *
 * Appel de HOOK dans un thème
 *	eval($plxShow->callHook("ThemeEndHead","1"))  ou eval($plxShow->callHook("ThemeEndHead",array("1","2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","1"));
 */